varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform mediump float intensity;
uniform mediump float ditherIntensity;
uniform lowp vec3 color1, color2, color3, color4, color5, color6, color7, color8, color9, color10, color11, color12, color13, color14, color15, color16;
precision mediump float;

//adapted from https://www.shadertoy.com/view/MdfXDH by Coldberg

vec3 find_closest (vec3 ref) {	
	vec3 old = vec3 (100.0);		
	#define TRY_COLOR(new) old = mix (new, old, step (length (old-ref), length (new-ref)));	
	TRY_COLOR (color1);
	TRY_COLOR (color2);
	TRY_COLOR (color3);
	TRY_COLOR (color4);
	TRY_COLOR (color5);
	TRY_COLOR (color6);
	TRY_COLOR (color7);
	TRY_COLOR (color8);
	TRY_COLOR (color9);
	TRY_COLOR (color10);
	TRY_COLOR (color11);
	TRY_COLOR (color12);
	TRY_COLOR (color13);
	TRY_COLOR (color14);
	TRY_COLOR (color15);
	TRY_COLOR (color16);

	return old ;
}

float dither_matrix (float x, float y) {
	return mix(mix(mix(mix(mix(mix(0.0,32.0,step(1.0,y)),mix(8.0,40.0,step(3.0,y)),step(2.0,y)),mix(mix(2.0,34.0,step(5.0,y)),mix(10.0,42.0,step(7.0,y)),step(6.0,y)),step(4.0,y)),mix(mix(mix(48.0,16.0,step(1.0,y)),mix(56.0,24.0,step(3.0,y)),step(2.0,y)),mix(mix(50.0,18.0,step(5.0,y)),mix(58.0,26.0,step(7.0,y)),step(6.0,y)),step(4.0,y)),step(1.0,x)),mix(mix(mix(mix(12.0,44.0,step(1.0,y)),mix(4.0,36.0,step(3.0,y)),step(2.0,y)),mix(mix(14.0,46.0,step(5.0,y)),mix(6.0,38.0,step(7.0,y)),step(6.0,y)),step(4.0,y)),mix(mix(mix(60.0,28.0,step(1.0,y)),mix(52.0,20.0,step(3.0,y)),step(2.0,y)),mix(mix(62.0,30.0,step(5.0,y)),mix(54.0,22.0,step(7.0,y)),step(6.0,y)),step(4.0,y)),step(3.0,x)),step(2.0,x)),mix(mix(mix(mix(mix(3.0,35.0,step(1.0,y)),mix(11.0,43.0,step(3.0,y)),step(2.0,y)),mix(mix(1.0,33.0,step(5.0,y)),mix(9.0,41.0,step(7.0,y)),step(6.0,y)),step(4.0,y)),mix(mix(mix(51.0,19.0,step(1.0,y)),mix(59.0,27.0,step(3.0,y)),step(2.0,y)),mix(mix(49.0,17.0,step(5.0,y)),mix(57.0,25.0,step(7.0,y)),step(6.0,y)),step(4.0,y)),step(5.0,x)),mix(mix(mix(mix(15.0,47.0,step(1.0,y)),mix(7.0,39.0,step(3.0,y)),step(2.0,y)),mix(mix(13.0,45.0,step(5.0,y)),mix(5.0,37.0,step(7.0,y)),step(6.0,y)),step(4.0,y)),mix(mix(mix(63.0,31.0,step(1.0,y)),mix(55.0,23.0,step(3.0,y)),step(2.0,y)),mix(mix(61.0,29.0,step(5.0,y)),mix(53.0,21.0,step(7.0,y)),step(6.0,y)),step(4.0,y)),step(7.0,x)),step(6.0,x)),step(4.0,x));
}

vec3 dither (vec3 color, vec2 uv) {	
	color += (dither_matrix (mod (uv.x, 8.0), mod (uv.y, 8.0)) * ditherIntensity) / 255.0;
	color = find_closest (clamp (color, 0.0, 1.0));
	return color;
}

void main(void)
{
    vec4 front = texture2D(samplerFront, vTex);
    gl_FragColor = mix(front, vec4(dither (front.rgb, gl_FragCoord.xy), front.a), intensity);
}